Program ProgRt; {  Ver 2.2 }
Uses FDelay,crt, dos;
Label Rett, Endd, RetS, Wer ;
Var
 ak : char;
 c,s0,s31,ss :byte;
 RomFile : file of byte;    {     }
 OvrFile,CmpFile,NblFile,IniF,TxtFile,TxtFileE : text;
 DumpR1 : array [0..$3FFF] of byte; { ⠥ 㤠 1 ࠧ }
 DumpR2 : array [0..$3FFF] of byte; { ⠥ 㤠 2 ࠧ }
 DumpW  : array [0..$3FFF] of byte;  {  襬 }
 lptN,b,t8,Adr,tk : Word;
 Tprg : LongInt;
 Sec,Rom,a,SetRom,RomType : Integer;
 NameF,ExtF,pr,FView : String;
 {$M 8192,0,0 }   { 16K stack, no heap }
{ ****************************************************************** }
{  H HHH  < 28 ms   }
Procedure Waitt(Tick:LongInt);     {  ᥪ㭤 }
var Ghj,Lkr :longint;
begin
 Lkr:= Round( int ( Tick/50000));  { 쪮 ࠧ  50000 }
 for Ghj:= 0 to Lkr do begin
  tk:= Round(Tick*1.19318);
  Asm
   CLI                         {Waiting in i8053/i8054 timer ticks}
   IN AL,61h                {Every timer's tick = 1/1193180 sec}
   AND AL,11111100B
   INC AX
   OUT 61h,AL
   MOV AL,0B0h
   OUT 43h,AL
   MOV AX,Tk
   OUT 42h,AL
   MOV AL,AH
   OUT 42h,AL
   IN AL,42h
   IN AL,42h
   @:
   IN AL,42h
   IN AL,42h
   CMP AL,AH
   JBE @
   STI
  End;
 end;
end;
{ ************************************************************** }
Procedure RReset;    {    + 祭 }
begin
 asm
  mov dx,lptN
  inc dx
  inc dx
  mov al,$23     { 0010 0011}
  out dx,al     { Reset - 16  lpt _Init_  -- 0 }
 end;
 Waitt (500000);
 asm
  mov dx,lptN
  inc dx
  inc dx
  mov al,$27   {  0010 0111     Reset - 16  lpt _Init_   -- 1 }
  out dx,al
 end;
 Waitt (200000);
 asm
  mov dx,lptN
  inc dx
  inc dx
  mov al,$23
  out dx,al     { Reset - 16  lpt _Init_  --  0 }
 end;
 Waitt (200000);
end;
{ ************************************************************** }
Procedure OffDev;
begin
 asm
  mov dx,lptN
  inc dx
  inc dx
  mov al,$2B     { 0010 1011 }
  out dx,al     { Reset - 16  lpt _Init_  --  0 }
 end;
end;
{ ****************************************************************** }
Function Dec2Hex (Value:byte): string;   { ॢ .  ᭠.}
 Function d2h (Value:byte): char;        {                    }
 begin
  case value of
   0..9   : d2h:= chr (value+$30);
   10..15 : d2h:= chr (value+$37);
  end;
 end;
begin
if SetRom = 1 then Dec2Hex:= d2h(value and $0F)
 else Dec2Hex:= d2h(value div $10) + d2h(value and $0F);
end;
{ ******************************************************************** }
Function Dec4Hex(Value:word):string;   { ॢ .  ᭠.}
var                                    {  ᫮                 }
 bh,bl : byte;
 pr : string;
 Function d4h(Value:byte):char;
 begin
  case value of
   0..9   : d4h:= chr (value+$30);
   10..15 : d4h:= chr (value+$37);
  end;
 end;
begin
 bh:= Hi(value);
 bl:= Lo(value);
 pr:= d4h(bh div $10) + d4h(bh and $0F);
 Dec4Hex:= pr + d4h(bl div $10) + d4h(bl and $0F);
end;
{ ******************************************************************** }
Function Dec2Bin (Value:byte): string;
 Function d2b (Value:byte): string;
 begin
  case value of
   0  : d2b:= '0000';
   1  : d2b:= '0001';
   2  : d2b:= '0010';
   3  : d2b:= '0011';
   4  : d2b:= '0100';
   5  : d2b:= '0101';
   6  : d2b:= '0110';
   7  : d2b:= '0111';
   8  : d2b:= '1000';
   9  : d2b:= '1001';
   10 : d2b:= '1010';
   11 : d2b:= '1011';
   12 : d2b:= '1100';
   13 : d2b:= '1101';
   14 : d2b:= '1110';
   15 : d2b:= '1111';
  end;
 end;
begin
 Dec2Bin:= d2b(value div $10) + d2b(value and $0F);
end;
{ ****************************************************************** }
Procedure Scroll;
begin
 asm           {  1 lpt - ⠪  -  "1"  -   ᨥ }
  mov dx,lptN
  inc dx
  inc dx
  in al,dx
  and al,$FE
  out dx,al
 end;
 asm             {  -  1 lpt -   "0" -   ᨥ }
  mov dx,lptN
  inc dx
  inc dx
  in al,dx
  or al,$01
  out dx,al
 end;
end;
{ ********************************************************************* }
Function ReadByte:byte;   { ⠥    }
var Rb: byte;
begin
 asm
  mov dx,lptN
  in al,dx        { ⠥  }
  mov Rb,al
 end;
 if SetRom = 1 then
  asm
   mov al,Rb
   and al,$0F
   mov Rb,al
  end;
ReadByte:= Rb;
end;
{ ******************************************************************* }
Procedure PrgImp (bitP:byte);    { ணࠬ騩  }
begin
 asm
  mov dx,lptN
  mov al,$00
  out dx,al
  inc dx
  inc dx              { +  5    0 }
  in al,dx
  and al,$DD          { 14  lpt - ண. . _Auto LF_}
  out dx,al  	      { ⠢ +5 襬 0 (⮦  ᨥ) }
  dec dx
  dec dx
  mov al,bitP
  out dx,al
 end;
 Waitt (Tprg);
 asm
  mov dx,lptN
  mov al,$00
  out dx,al
  inc dx
  inc dx
  in al,dx
  or al,$22          { 14  lpt - ண. . _Slet In_}
  out dx,al            { ⠢ GND, 襬 1( ⮦  ᨥ) }
 end;
 Waitt (Tprg);
end;
{ ********************************************************************* }
Procedure WriteByte (pr:byte);      { 襬    }
label lop;
var cv,sc,cv1 : integer;
 rm,brr : byte;
begin
 sc:= sec;
 lop:
 brr:= ReadByte;
 if SetRom = 1 then cv1:= 3 else cv1:= 7;
 for cv:= 0 to cv1 do begin
  Case cv of
   0 : Rm:= $01;
   1 : Rm:= $02;
   2 : Rm:= $04;
   3 : Rm:= $08;
   4 : Rm:= $10;
   5 : Rm:= $20;
   6 : Rm:= $40;
   7 : Rm:= $80;
  end;
  if RomType = 1 then     {  5/17 }
   asm
    mov dx,lptN
    mov ah,rm      { ᪠ }
    mov al,brr     {    }
    mov bl,pr      { 祣   }
    and al,ah      { 1 -   }
    not bl
    and ah,bl      { 1 - ᫨   }
    and al,ah
    mov Rm,al
   end
  else
   asm  	  {  ᥣ ⠫쭮 }
    mov dx,lptN
    mov ah,rm      { ᪠ }          {}
    mov al,brr     {    }   {1001}
    mov bl,pr      { 祣   } {1010}
    not al
    and al,bl      { 1 -   } {1000}
    and al,ah      { 1 - ᫨   }
    mov Rm,al
   end;
 if Rm <> 0 then PrgImp (Rm);
 end;
 if (ReadByte = brr) and (sc <> 0) then begin
  sc:= sc - 1;
  goto lop;
 end;
end;
{ ******************************************************************** }
Function FileIn: String;  {  䠩  ࠧ७ }
var i : String;
begin
 if ( ParamCount = 1 ) and
  ( Length(ParamStr(1)) < 9 ) and
  ( Pos(ParamStr(1),'.rom') <> 0 ) and
  ( Pos(ParamStr(1),'.ROM') <> 0 ) then i:= Copy (ParamStr(1),1,Pos(i,'.')-1)
 else
 begin
  TextColor(10);
  Write ('  䠩 ( ࠧ७) : ');
  Readln(i);
  if Length(i) > 8 then i:= Copy(i,1,8);
   { ᫨   8 ᨬ -  譨 }
  TextColor(7);
 end;
FileIn:= i
end;
{ ******************************************************************** }
Procedure CClear;
var ft: byte;
begin
 GotoXY (1,WhereY-8);
 for ft:= 0 to 7 do DelLine;
end;
{ ******************************************************************** }
{ ******************************************************************** }
Procedure ReadPROM;   {  ணࠬ ⥭  }
Label Eend;
var
 s0 : Byte;
begin
 CClear;
 { -------  ⠥ 1 ࠧ -----------}
 TextColor(3);
 Writeln ('    ⥭ .');
 TextColor(7);
 NameF:= FileIn;
 if NameF = '' then begin
  TextColor(4);
  Writeln(' ⬥ !!');
  TextColor(7);
  goto Eend;
 end;
 RReset;  {  }
 TextColor(14);
 Write ('       -  ');
 Writeln(Dec4Hex(Rom));
 TextColor(2);
 Gotoxy(10,WhereY);
 Write('    - ');
 For b:= 0 to Rom do            { ⠥ Rom 祥 ` }
 begin
  Gotoxy(27,WhereY);
  Write(Dec4Hex(b));
  DumpR1[b]:= ReadByte;
  Scroll;
 end;
 Writeln;
 { ------- ⠥ 2 ࠧ --------}
 RReset;
 TextColor(6);
 Gotoxy(8,WhereY);
 Write('஢   - ');
 For b:= 0 to Rom do            { ⠥ Rom 祥 ` }
 begin
  Gotoxy(27,WhereY);
  Write(Dec4Hex(b));
  DumpR2[b]:= ReadByte;
  if DumpR1[b] <> DumpR2[b] then begin
   TextColor(4);
   Writeln;
   Write ('  !!!! **** !!!! 訡     -  ');
   Write(Dec4Hex(b));
   Write ('   / ');
   Write(Dec2Hex(DumpR1[b]));
   Write ('-');
   Writeln (Dec2Hex(DumpR2[b]));
   TextColor(7);
   goto Eend;
  end;
  Scroll;
 end;
 Writeln;
 ExtF:= NameF+'.rom';
 Assign(RomFile,ExtF);     {  Rom 䠩 }
 ReWrite(RomFile);
 For b:= 0 to Rom do Write(RomFile,DumpR1[b]);   {   }
 Close(RomFile);
 ExtF:= NameF+'.txt';
 Assign(TxtFile,ExtF);    {   䠩 }
 ReWrite(TxtFile);
 Write(TxtFile,' Adr');
 for a:= 0 to 15 do        {  ᢥ 䠩 }
 begin
  Write(TxtFile,'  ');
  Write(TxtFile,Dec2Hex(a));
 end;
 Writeln(TxtFile,'');
 Adr:= 16;
 For b:= 0 to Rom do
 begin
  Dec(Adr);
  if adr > 14 then       {  ᫥   }
  begin
   Writeln(TxtFile,'');
   Write(TxtFile,Dec4Hex(b));
   Write(TxtFile,'  ');
   Adr:= 15;
  end;
  Write(TxtFile,Dec2Hex(DumpR1[b]));   {   }
  Write(TxtFile,'  ');
 end;
 Close(TxtFile);
 Eend:
 OffDev;
 TextColor(7);
end;
{ ******************************************************************* }
{ ******************************************************************* }
Procedure WritePROM;       {   }
label Rew1,reww;
var
 s1 : byte;
 b : word;
begin
 CClear;
 TextColor(3);
 Writeln ('      .');
 TextColor(4);
 Writeln ('            䠩  ஢ !!!!');
 Writeln ('       ⮫쪮 ` ⠫  砫 䠩 !');
 TextColor(7);
 NameF:= FileIn;
 if NameF = '' then begin
  TextColor(4);
  Writeln(' ⬥ !!');
  TextColor(7);
  goto Rew1;
 end;
 Assign (RomFile,NameF+'.rom');
 {$I-}
 Reset (RomFile);
 {$I+}
 if IOResult <> 0 then begin
  TextColor(4);
  Writeln (' *******       !!!   ********* ');
  Goto Rew1;
 end;
 For b:= 0 to Rom do Read (RomFile,DumpW[b]);{४뢠  䠩  ᨢ}
 Close(RomFile);
 TextColor(14);
 RReset;
 Write ('       -  ');
 Writeln(Dec4Hex(Rom));
 TextColor(2);
 Gotoxy(9,WhereY);
 Write('      - ');
 Gotoxy(52,WhereY);
 For b:= 0 to Rom do            { 襬 Rom 祥 ` }
 begin
  Gotoxy(27,WhereY);
  Write(Dec4Hex(b));
  WriteByte (DumpW[b]);
  Scroll;
 end;
 RReset;
 Writeln;
 TextColor(6);       {  ஢ઠ 'x}
 Gotoxy(1,WhereY);
 Write('           -  ');
 For b:= 0 to Rom do            { ⠥ Rom 祥 ` }
 begin
  Gotoxy (27,WhereY);
  Write (Dec4Hex(b));
  DumpR1[b]:= ReadByte;
  Scroll;
 end;
 RReset;
 For b:= 0 to Rom do            { ⠥ Rom 祥 ` }
 begin
  Gotoxy (27,WhereY);
  Write (Dec4Hex(b));
  DumpR2[b]:= ReadByte;
  if (DumpW[b] <> DumpR2[b]) and (DumpW[b] <> DumpR1[b]) then goto reww;
  Scroll;
 end;
 OffDev;
 TextColor(10);
 Writeln;
 Writeln('   祭 ᯥ譮 .');
 goto Rew1;
 Reww:
 OffDev;
 TextColor(9);
 Writeln;
 Write('  䠩 ᮤঠ騩 娥 祩 . ');
 Write ('  - ');
 Write (NameF);
 Writeln ('.err');
 Assign(TxtFileE,NameF+'.err');    {   䠩 }
 ReWrite(TxtFileE);
 Write (TxtFileE,' 娥 祩  ᫥ 訢 䠩 ');
 Write (TxtFileE,NameF);
 Writeln (TxtFileE,'.rom');
 Writeln (TxtFileE,'');
 Writeln(TxtFileE,'                 ---  .');
 Writeln (TxtFileE,'');
 For b:= 0 to Rom do begin
  if DumpW[b] <> DumpR1[b] then begin
   Write(TxtFileE,Dec4Hex(b));   { p }
   Write(TxtFileE,'    ');
   Write(TxtFileE,Dec2Hex(DumpW[b]));   {  }
   Write(TxtFileE,'  ');
   Write(TxtFileE,Dec2Bin(DumpW[b]));   {  }
   Write(TxtFileE,' --- ');
   Write(TxtFileE,Dec2Hex(DumpR1[b]));   {   }
   Write(TxtFileE,'  ');
   Write(TxtFileE,Dec2Bin(DumpR1[b]));
   Writeln(TxtFileE,'');
  end;
 end;
 Close(TxtFileE);
 Rew1:
 TextColor(7);
end;
{ ******************************************************************* }
{ ******************************************************************* }
Procedure EditRom;       { 㥬 䠩  }
begin
 CClear;
 TextColor(3);
 Writeln ('  ஢ ᮤন .');
 TextColor(7);
 NameF:= FileIn;
 if NameF <> '' then NameF:= NameF+'.rom';
 SwapVectors;
 Exec (FView,NameF);
 SwapVectors;
 TextColor(7);
end;
{ ******************************************************************* }
{ ******************************************************************* }
Procedure SSetup;    { ன }
var aa : char;
begin
 CClear;
 TextColor(3);
 Writeln ('    ன ணࠬ.');
 TextColor(11);
 Writeln('    LPT ?  ');
 TextColor(1);
 Write ('378h');
 Writeln('      LPT 1  -  1');
 Write ('278h');
 Writeln('      LPT 2  -  2');
 Write ('3BCh');
 Writeln('      LPT 3  -  3');
 aa:= ReadKey;
 Case aa of
  '1' : lptN:=$378;
  '2' : lptN:=$278;
  '3' : lptN:=$3BC;
 else
  lptN:=$378;
 end;
 TextColor(2);
 Write('   ६ ணࠬ饣  () ?  ');
 Readln(Tprg);
 TextColor(3);
 Write('   ⢮ ⮪ ணࠬ஢ ?  ');
 Readln(Sec);
 TextColor(7);
 if Tprg > 1000000 then Tprg:= 1000000;
 if Sec > 1000 then Sec:= 1000;
 if Tprg < 1 then Tprg:= 1;
 if Sec < 1 then Sec:= 1;
 ReWrite(IniF);            { 襬  setup }
 Writeln (IniF,lptN);
 Writeln (IniF,Tprg);
 Writeln (IniF,Sec);
 Writeln (IniF,Fview);
 Close (IniF);
end;
{ ******************************************************************* }
{ ******************************************************************* }
Procedure VBlank;    { ஢ઠ   }
label Rew2,Rew23;
var s2 : byte;
begin
 CClear;
 TextColor(3);
 Writeln ('    ஢ઠ   .');
 RReset;                      {  }
 TextColor(14);
 Write ('       -  ');
 Writeln(Dec4Hex(Rom));
 TextColor(2);
 Gotoxy(10,WhereY);
 Write('    - ');
 For b:= 0 to Rom do            { ⠥ Rom 祥 ` }
 begin
  Gotoxy(27,WhereY);
  Write(Dec4Hex(b));
  DumpR1[b]:= ReadByte;
  if RomType = 1 then begin
   s2:= DumpR1[b]; { 㥬   5/17 }
   asm
    mov al,s2
    not al
    mov s2,al
   end;
   DumpR1[b]:= s2;
  end;
  if DumpR1[b] <> 0 then goto Rew23;
  Scroll;
 end;
 Writeln;
 OffDev;
 TextColor(11);
 Writeln ('    -  ! ');
 Goto Rew2;  {**************************}
 Rew23:
 TextColor(3);
 Writeln;
 Writeln ('    - ___ ! ');
 Writeln (' ᮪ ___ 祥  .');
 NameF:= FileIn;
 if NameF = '' then begin
  TextColor(4);
  Writeln(' ⬥ !');
  TextColor(7);
  Goto Rew2;
 end;
 NameF:= NameF+'.Nbl';
 Assign (NblFile,NameF);
 ReWrite(NblFile);
 Writeln (NblFile,'     ___ 祩  . ');
 Writeln(NblFile,'');
 RReset;
 For b:= 0 to Rom do begin
  DumpR1[b]:= ReadByte;
  DumpR2[b]:= DumpR1[b];
  if RomType = 1 then begin
   s2:= DumpR1[b]; { 㥬   5/17 }
   asm
    mov al,s2
    not al
    mov s2,al
   end;
   DumpR1[b]:= s2;
  end;
  if DumpR1[b] <> 0 then begin
   Write(NblFile,Dec4Hex(b));   { p }
   Write(NblFile,'  ');
   Write(NblFile,Dec2Hex(DumpR2[b]));   {   }
   Write(NblFile,'  ');
   Write(NblFile,Dec2Bin(DumpR2[b]));   {   }
   Writeln(NblFile,'');
  end;
  Scroll;
 end;
 Close(NblFile);
 TextColor(7);
 Rew2:
 OffDev;
 TextColor(7);
end;
{ ******************************************************************* }
{ ******************************************************************* }
Procedure CompD;        { ࠢ }
label Rew3,Rew32;
var s2 : byte;
begin
 CClear;
 TextColor(3);
 Writeln (' ࠢ ᮤন   䠩 .');
 NameF:= FileIn;
 if NameF = '' then begin
  TextColor(4);
  Writeln(' ⬥ !');
  TextColor(7);
  goto Rew3;
 end;
 Assign (RomFile,NameF+'.rom');
 {$I-}
 Reset (RomFile);
 {$I+}
 if IOResult <> 0 then begin
  TextColor(4);
  Writeln (' *******       !!!   ********* ');
  Goto Rew3;
 end;
 For b:= 0 to Rom do begin
  Read(RomFile,DumpR1[b]);       { ४뢠  䠩  ᨢ }
  if SetRom = 1 then begin
   s2:= DumpR1[b];    { ࠢ塞 訥 1/0  0  SetRom=1 }
   asm
    mov al,s2
    and al,$0F
    mov s2,al
   end;
   DumpR1[b]:= s2;
  end;
 end;
 Close(RomFile);
 RReset;                      {  }
 TextColor(5);
 Write ('           -  ');
 Writeln(Dec4Hex(Rom));
 TextColor(2);
 Gotoxy(14,WhereY);
 Write('    - ');
 For b:= 0 to Rom do            { ⠥ Rom 祥 ` }
 begin
  Gotoxy(31,WhereY);
  Write(Dec4Hex(b));
  Scroll;
 end;
 OffDev;
 For b:= 0 to Rom do if DumpR2[b] <> DumpR1[b] then goto Rew32;
 TextColor(11);
 Writeln;
 Writeln ('     ᮤন  -   .');
 Goto Rew3;       {************************}
 Rew32:
 TextColor(3);
 Writeln;
 Write ('  ᯨ᮪ ___ 祥 .  ');
 Write ('  - ');
 Write (NameF);
 Writeln ('.cmp');
 Assign (CmpFile,NameF+'.cmp');
 ReWrite(CmpFile);
 Write (CmpFile,'  ࠢ 䠩 ');
 Write (CmpFile,NameF);
 Write (CmpFile,'.rom');
 Writeln (CmpFile,'  .');
 Writeln (CmpFile,'');
 Writeln(CmpFile,'                --  .');
 Writeln (CmpFile,'');
 For b:= 0 to Rom do
  if DumpR1[b] <> DumpR2[b] then begin
   Write(CmpFile,Dec4Hex(b));   { p }
   Write(CmpFile,'   ');
   Write(CmpFile,Dec2Hex(DumpR1[b]));   {  }
   Write(CmpFile,'  ');
   Write(CmpFile,Dec2Bin(DumpR1[b]));   {  }
   Write(CmpFile,' -- ');
   Write(CmpFile,Dec2Hex(DumpR2[b]));   {   }
   Write(CmpFile,'  ');
   Write(CmpFile,Dec2Bin(DumpR2[b]));   {  }
   Writeln(CmpFile,'');
  end;
 Close(CmpFile);
 TextColor(7);
 Rew3:
 TextColor(7);
end;
{ ******************************************************************* }
{ ******************************************************************* }
Procedure OvrPut;        { ஢ઠ  }
label Rew4,Rew42;
var s2,s3,s4,b1,b2,b3,v : byte;
begin
 CClear;
 TextColor(3);
 Writeln ('஢   䠩  .');
 NameF:= FileIn;
 if NameF = '' then begin
  TextColor(4);
  Writeln(' ⬥ !');
  TextColor(7);
  goto Rew4;
 end;
 Assign (RomFile,NameF+'.rom');
 {$I-}
 Reset (RomFile);
 {$I+}
 if IOResult <> 0 then begin
  TextColor(4);
  Writeln (' *******       !!!   ********* ');
  Goto Rew42;
 end;
 For b:=0 to Rom do begin
  Read(RomFile,DumpR1[b]);       { ४뢠  䠩  ᨢ }
  if SetRom = 1 then begin
   s2:= DumpR1[b];    { ࠢ塞 訥 1/0  0  SetRom=1 }
   asm
    mov al,s2
    and al,$0F
    mov s2,al
   end;
   DumpR1[b]:= s2;
  end;
 end;
 Close(RomFile);
 RReset;                    {  }
 TextColor(5);
 Write ('           -  ');
 Writeln(Dec4Hex(Rom));
 TextColor(2);
 Gotoxy(14,WhereY);
 Write('    - ');
 For b:= 0 to Rom do            { ⠥ Rom 祥 ` }
 begin
  Gotoxy(31,WhereY);
  Write(Dec4Hex(b));
  DumpR2[b]:= ReadByte;
  Scroll;
 end;
 OffDev;
 For b:= 0 to Rom do begin
  b1:= DumpR1[b];     { 䠩 }
  b2:= DumpR2[b];      {  }
  if RomType = 1 then begin
   asm           { ஢ઠ   5/17 }
    mov al,b2
    mov ah,b1
    not ah
    or al,ah
    mov b1,al
   end;
   end else begin
   asm           { ஢ઠ  }
    mov al,b1
    mov ah,b2
    not ah
    or al,ah
    mov b1,al
   end;
  end;
  if b1 <> $FF then Goto Rew4;
 end;
 Writeln;
 TextColor(10);
 Writeln ('     ᮤন  .');
 Goto Rew42;
 Rew4:      {*******************}
 Writeln;
 TextColor(3);
 Writeln ('  ᯨ᮪ 祥     ___.  ');
 Write ('         - ');
 Write (NameF);
 Writeln ('.ovr');
 Assign (OvrFile,NameF+'.ovr');
 ReWrite(OvrFile);
 Write (OvrFile,'  ஢ન 䠩 ');
 Write (OvrFile,NameF);
 Write (OvrFile,'.rom');
 Writeln (OvrFile,'    .');
 Writeln (OvrFile,'');
 Writeln(OvrFile,'                 ---  .             "1"- Ok.');
 Writeln (OvrFile,'');
 For b:= 0 to Rom do            {  }
 begin
  b1:= DumpR1[b];     { 䠩 }
  b2:= DumpR2[b];      {  }
  if SetRom = 1 then begin
   s2:= b1;    { ࠢ塞 訥 1/0  1  SetRom=1 }
   s3:= b2;
   asm
    mov al,s2
    or al,$F0
    mov s2,al
    mov ah,s3
    or al,$F0
    mov s3,ah
   end;
    b2:= s3;
    b1:= s2;
  end;
  DumpR1[b]:= b1;
  if RomType = 1 then begin
   asm           { ஢ઠ   5/17 }
    mov al,b2
    mov ah,b1
    not ah
    or al,ah
    mov b1,al
   end;
   end else begin
   asm           { ஢ઠ  }
    mov al,b1
    mov ah,b2
    not ah
    or al,ah
    mov b1,al
   end;
  end;
  if b1 <> $FF then begin
   Write(OvrFile,Dec4Hex(b));   { p }
   Write(OvrFile,'    ');
   Write(OvrFile,Dec2Hex(DumpR1[b]));   {  }
   Write(OvrFile,'  ');
   Write(OvrFile,Dec2Bin(DumpR1[b]));   {  }
   Write(OvrFile,' --- ');
   Write(OvrFile,Dec2Hex(b2));   {   }
   Write(OvrFile,'  ');
   Write(OvrFile,Dec2Bin(b2));   {  }
   Write(OvrFile,'    (');
   Write(OvrFile,Dec2Bin(b1));   {  }
   Writeln(OvrFile,')');
  end;
 end;
 Close(OvrFile);
 Rew42:
 TextColor(7);
end;
{ ******************************************************************* }
{ ******************************************************************* }
{ ***************  ᭮ 窠  ********************* }
Begin
 OffDev;
 assign (IniF,'ProgRt.ini');
 {$I-}
 Reset(IniF);     { ஢ઠ 䠩 ini }
 {$I+}
 if IOResult <> 0 then begin   { 䠩   }
  lptN:= $378;               {    㬮砭 }
  Tprg:= 10000;            { ६ ண   㬮砭 }
  Sec:= 70;            { - ⮪ ணࠬ஢ }
  FView:= 'QView.exe';        {  譥 । }
  ReWrite(IniF);
  Writeln (IniF,lptN);
  Writeln (IniF,Tprg);
  Writeln (IniF,Sec);
  Writeln (IniF,Fview);
 end else begin              { 䠩  - ⠥ }
  Readln (IniF,lptN);
  Readln (IniF,Tprg);
  Readln (IniF,Sec);
  Readln (IniF,Fview);
 end;
 Close (IniF);
 if Tprg > 1000000 then Tprg:= 1000000;
 if Sec > 1000 then Sec:= 1000;
 if Tprg < 1 then Tprg:= 1;
 if Sec < 1 then Sec:= 1;
 TextBackGround (0);
 Wer:
 Clrscr;
 TextColor(14);
 Writeln (' .㫠.  () Andrey Bivshih, 2000 .         Ver.2.2.');
 Writeln;
 TextColor(11);
 Writeln ('      ணࠬ  . ');
 TextColor(7);
 Writeln;
 Writeln ('                               室 - Ctrl+Break  ');
 Writeln;
 TextColor(10);
 Writeln ('         ? ');
 TextColor(13);
 Writeln;
 Writeln ('  1553       -  1');
 Writeln ('  5411       -  2');
 Writeln ('  5564,11    -  2');
 Writeln ('  55612,13   -  3');
 Writeln ('  5565,17    -  4');
 Writeln ('  55620      -  5');
 Writeln ('  55614,15   -  6');
 Writeln ('  5569       -  7');
 Writeln ('  55616      -  8');
 Writeln ('  5412       -  9');
 Writeln ('  5566,7,18  -  9');
 ak:= ReadKey;
 TextColor(7);
 if (ak='2') or (ak='3') or (ak='6') then SetRom:= 1
   else SetRom:= 0;         {   - 4  }
 if ak='4' then RomType:= 1 else RomType:= 0; {  -> "1"}
 Case ak of       {  `    }
  '1' : Rom:=$1F;
  '2' : Rom:=$FF;
  '3' : Rom:=$3FF;      {    }
  '4' : Rom:=$1FF;
  '5' : Rom:=$FFF;
  '6' : Rom:=$7FF;
  '7' : Rom:=$3FFF;
  '8' : Rom:=$1FFF;
  '9' : Rom:=$7FF;
  chr(27) : goto Endd;
 else goto Wer;
 end;
 TextColor(12);
 if SetRom=1 then Writeln('  - 4 . C訥 4    !');
 TextColor(6);
 if RomType=1 then Writeln('     ⮩  -  "1".')
  else Writeln('     ⮩  -  "0".');
 TextColor(3);
 Write   (' 㭪 - ');
 Write (ak);
 TextColor(2);
 Write   ('   `  ⠫ - ');
 Write (Rom+1);
 Write   ('  , (᫥  - ');
 Write   (Dec4Hex(Rom));
 Writeln (').');
 Rett:
 TextColor(14);
 Writeln ('   ................ 1');
 Writeln ('   .................. 2');
 Writeln ('  ஢ ......... 3');
 Writeln ('  ࠢ .............. 4');
 Writeln ('  ஢   .. 5');
 Writeln ('  ஢ઠ  .... 6');
 Writeln ('   ⨯  ....... 7');
 Writeln ('  ன ............. 8');
 TextColor(7);
 Gotoxy(43,18);
 Write ('======================================');
 Gotoxy(43,19);
 Write ('!    ........... ');
 Write (Dec4Hex(lptN));
 Gotoxy(43,20);
 Write ('!  ६ ண () ...... ');
 Write (Tprg);
 Gotoxy(43,21);
 Write ('!  - ⮪ ........ ');
 Write (Sec);
 Gotoxy(43,22);
 Write ('!  ᫥  ....... ');
 Write (Dec4Hex(Rom));
 Gotoxy(43,23);
 Write ('======================================');
 ak:= ReadKey;
 TextColor(7);
 Case ak of
  '1' : ReadPROM;
  '2' : WritePROM;
  '3' : EditRom;
  '4' : CompD;
  '5' : VBlank;
  '6' : OvrPut;
  '7' : Goto Wer;
  '8' : SSetup;
  chr(27) : Goto Endd;
 else Gotoxy(1,17);
 end;
 Goto Rett;
 Endd:
 OffDev;
End.
